// This file was generated by createCFunction.sci on 13-03-2015 15:33

// Computational function for X2C block SinGen

#define MATLAB_MEX_FILE

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <SinGen_FiP16.h>
#include <SinGen_FiP16.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_SinGen_FiP16_C(scicos_block* block, scicos_flag flag);
static void x2c_SinGen_FiP16_C__OutputUpdate(scicos_block* block);
static void x2c_SinGen_FiP16_C__StateUpdate(scicos_block* block);
static void x2c_SinGen_FiP16_C__Initialization(scicos_block* block);
static void x2c_SinGen_FiP16_C__Ending(scicos_block* block);


void x2c_SinGen_FiP16_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_SinGen_FiP16_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_SinGen_FiP16_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_SinGen_FiP16_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_SinGen_FiP16_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_SinGen_FiP16_C__set_parameter(scicos_block* block, SINGEN_FIP16 *blockParam) {
    int *paramI;
    double *paramR;
    SINGEN_FIP16 *pTSinGen_FiP16;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTSinGen_FiP16 = GetWorkPtrs(block);
    blockParam->delta_phi = (int16)paramI[0];
    blockParam->phase = (int16)paramI[1];
    blockParam->offset = (int16)paramI[2];
}


static void x2c_SinGen_FiP16_C__Initialization(scicos_block* block) {
    SINGEN_FIP16 *pTSinGen_FiP16;

    /* Declaration of inports */
    double *inport_A_p;
    int16 inport_A;
    double *inport_f_p;
    int16 inport_f;

    /* Declaration of outports */
    double *outport_u;

    /* *** */
    pTSinGen_FiP16 = scicos_malloc(sizeof(SINGEN_FIP16));
    GetWorkPtrs(block) = pTSinGen_FiP16;
    x2c_SinGen_FiP16_C__set_parameter(block, pTSinGen_FiP16);

    /* Assignment of inports */
    inport_A_p = GetInPortPtrs(block, 1);
    inport_A = (int16)( (*inport_A_p) * (double)((int16)1 << 15));
    pTSinGen_FiP16->A = &inport_A;
    inport_f_p = GetInPortPtrs(block, 2);
    inport_f = (int16)( (*inport_f_p) * (double)((int16)1 << 15));
    pTSinGen_FiP16->f = &inport_f;

    /* Initialization */
    SinGen_FiP16_Init(pTSinGen_FiP16);

    /* Assignment of outports */
    outport_u = GetOutPortPtrs(block, 1);
    *outport_u = (double)pTSinGen_FiP16->u / (double)((int16)1 << 15);
}


static void x2c_SinGen_FiP16_C__Ending(scicos_block* block) {
    SINGEN_FIP16 *pTSinGen_FiP16;
    pTSinGen_FiP16 = GetWorkPtrs(block);
    scicos_free(pTSinGen_FiP16);
}


static void x2c_SinGen_FiP16_C__StateUpdate_f(scicos_block* block) {
    SINGEN_FIP16 *pTSinGen_FiP16;

    /* Declaration of inports */
    double *inport_A_p;
    int16 inport_A;
    double *inport_f_p;
    int16 inport_f;

    /* *** */
    pTSinGen_FiP16 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_A_p = GetInPortPtrs(block, 1);
    inport_A = (int16)( (*inport_A_p) * (double)((int16)1 << 15));
    pTSinGen_FiP16->A = &inport_A;
    inport_f_p = GetInPortPtrs(block, 2);
    inport_f = (int16)( (*inport_f_p) * (double)((int16)1 << 15));
    pTSinGen_FiP16->f = &inport_f;

    /* Update */
    SinGen_FiP16_Update(pTSinGen_FiP16);
}


static void x2c_SinGen_FiP16_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_SinGen_FiP16_C__StateUpdate_f(block);
    }
}


static void x2c_SinGen_FiP16_C__OutputUpdate(scicos_block* block) {
    SINGEN_FIP16 *pTSinGen_FiP16;
    SINGEN_FIP16 tmpSinGen_FiP16;

    /* Declaration of outports */
    double *outport_u;

    /* *** */
    pTSinGen_FiP16 = GetWorkPtrs(block);

    /* Save work data */
    memcpy(&tmpSinGen_FiP16, pTSinGen_FiP16, sizeof(SINGEN_FIP16));

    /* *** */
    x2c_SinGen_FiP16_C__StateUpdate_f(block);

    /* Assignment of outports */
    outport_u = GetOutPortPtrs(block, 1);
    *outport_u = (double)pTSinGen_FiP16->u / (double)((int16)1 << 15);

    /* Copy back tmp data */
    memcpy(pTSinGen_FiP16, &tmpSinGen_FiP16, sizeof(SINGEN_FIP16));
}


